]> git.pld-linux.org Git - packages/rpm.git/blame - rpm.macros
- adapterized (killed trailing spaces/tabs)
[packages/rpm.git] / rpm.macros
CommitLineData
b52fc1f1 1# $Revision$, $Date$
a8bf9720
AF
2# PLD rpm macros
3
90c0eaed 4%epoch 0
31b569b6 5%x8664 x86_64 amd64 ia32e
cd33aab7 6
a544555d 7# kernel compiler
6f86c45e 8%kgcc %{__cc}
cabacfeb 9%kgcc_package gcc
a544555d 10
31b569b6
ER
11%_source_payload w9.gzdio
12%_binary_payload w9.bzdio
13
5f9f9bd7 14# Build system path macros.
15#
8af1c6f5
JB
16%__autoconf autoconf %{?debug:-Wall}
17%__automake automake -a -c -f --foreign
429d047e 18%__autopoint autopoint --force
19
aad1c8e4 20%__gettextize { \
31b569b6 21if ! gettextize --version | grep -q '0\.10\.' ; then \
4cd84746 22 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
31b569b6 23 gettextize --copy --force --no-changelog; \
93bce43f 24 else \
31b569b6 25 gettextize --copy --force --no-changelog --intl; \
4cd84746
JB
26 fi; \
27 if [ ! -f po/Makevars ]; then \
31b569b6 28 cp -f po/Makevars{.template,}; \
4cd84746 29 fi; \
31b569b6 30else \
4cd84746 31 gettextize --copy --force; \
31b569b6 32fi; \
4cd84746 33}
429d047e 34
35%__glib_gettextize glib-gettextize --copy --force
36%__gnome_doc_common gnome-doc-common --copy
37%__gtkdocize gtkdocize --copy
38%__intltoolize intltoolize --copy --force
39%__libtoolize libtoolize --copy --force
5f9f9bd7 40
bd1cd543 41%dependencytracking %{nil}
31b569b6 42
073ae3ba
ER
43# Relations between package names that cause dependency loops
44# with legacy packages that cannot be fixed. Relations are
45# specified as
46# p>q
47# where package p has a Requires: on something that package q Provides:
48#
49# XXX Note: that there cannot be any whitespace within the string "p>q",
50# and that both p and q are package names (i.e. no version/release).
51%_dependency_whiteout %{nil}
52
cd33aab7 53#-----------------------------------------------------------------
9f0287b5 54%configure2_13 { \
cd33aab7
AM
55 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
56 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
57 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
af18d245 58 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
cd33aab7 59 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
c55f2219 60 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
4eac2e49
AM
61 %{?__cc:CC="%{__cc}" ; export CC ; } \
62 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
5b0f0ac9 63 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
fa74a11c 64 --host=%{_target_platform} \
cd33aab7
AM
65 --prefix=%{_prefix} \
66 --exec-prefix=%{_exec_prefix} \
67 --bindir=%{_bindir} \
68 --sbindir=%{_sbindir} \
69 --sysconfdir=%{_sysconfdir} \
70 --datadir=%{_datadir} \
71 --includedir=%{_includedir} \
72 --libdir=%{_libdir} \
73 --libexecdir=%{_libexecdir} \
74 --localstatedir=%{_localstatedir} \
75 --sharedstatedir=%{_sharedstatedir} \
76 --mandir=%{_mandir} \
77 --infodir=%{_infodir} \
c3420100 78 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 79 %{dependencytracking} \
cd33aab7
AM
80}
81
85f82bec 82#----------------------------------------------------------------
7e4e3f2b 83%global configure_cache 0
84%configure_cache_file %{buildroot}.configure.cache
85
b8cf6778 86%configure {./configure \
85f82bec
AF
87 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
88 CFLAGS="${CFLAGS:-%rpmcflags}" \
af18d245 89 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
85f82bec 90 FFLAGS="${FFLAGS:-%rpmcflags}" \
418d9760 91 CPPFLAGS="${CPPFLAGS:-}" \
4eac2e49
AM
92 %{?__cc:CC="%{__cc}"} \
93 %{?__cxx:CXX="%{__cxx}"} \
a9bea0f7 94 --host=%{_target_platform} \
85f82bec
AF
95 --build=%{_target_platform} \
96 --prefix=%{_prefix} \
97 --exec-prefix=%{_exec_prefix} \
98 --bindir=%{_bindir} \
99 --sbindir=%{_sbindir} \
100 --sysconfdir=%{_sysconfdir} \
101 --datadir=%{_datadir} \
102 --includedir=%{_includedir} \
103 --libdir=%{_libdir} \
104 --libexecdir=%{_libexecdir} \
105 --localstatedir=%{_localstatedir} \
106 --sharedstatedir=%{_sharedstatedir} \
107 --mandir=%{_mandir} \
108 --infodir=%{_infodir} \
c3420100 109 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 110 %{dependencytracking} \
7e4e3f2b 111 %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
85f82bec
AF
112}
113
617b7266 114# ------------------------------------------------------------------------
a0bade1c
AM
115# Overloading of some basic macros
116%prep \
117%%prep\
118LANG=C\
119export LANG\
7febf367 120unset DISPLAY ||:\
7507b4fa 121unset LINGUAS ||:\
a0bade1c
AM
122%{nil}
123
124%build %%build\
125LANG=C\
126export LANG\
7febf367 127unset DISPLAY ||:\
7507b4fa 128unset LINGUAS ||:\
a0bade1c
AM
129%{nil}
130
1fcb29e9
ER
131%install \
132%if 0%{?_enable_debug_packages}\
133%{?buildsubdir:%{debug_package}}\
134%endif\
a0bade1c
AM
135%%install\
136LANG=C\
137export LANG\
7febf367 138unset DISPLAY ||:\
7507b4fa 139unset LINGUAS ||:\
a0bade1c
AM
140%{nil}
141
cd33aab7
AM
142# Location of autoconf macros
143%_aclocaldir %(aclocal --print-ac-dir)
144
32720a50
AM
145# Location of omf files
146%_omf_dest_dir %(scrollkeeper-config --omfdir)
147
c5eece2c 148# Location of pkgconfig files
a46897a7 149%_pkgconfigdir /usr/%{_lib}/pkgconfig
c5eece2c 150
c917274d 151# Location of desktop files
152%_desktopdir /usr/share/applications
510f694c 153%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
c917274d 154
fb08fb4a 155# Location of pixmaps for applnk/desktop files
3a9bb008 156%_pixmapsdir /usr/share/pixmaps
cd33aab7 157
fb08fb4a 158# Location of themable icons for applnk/desktop files
986c3bcd 159%_iconsdir /usr/share/icons
160
c5eece2c
JB
161# Location of fonts directories
162%_fontsdir /usr/share/fonts
163
5cfcbc9e 164# Location of Gtk and associated libraries documentation
e9f33a26 165%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
5cfcbc9e 166
eee08b2d 167# Location of KDE documentation
168%_kdedocdir %{_defaultdocdir}/kde/HTML
169
a7cad6ae 170# unsermake script
171%__unsermake /usr/share/unsermake/unsermake
172
cd33aab7
AM
173# Current date
174%date %(LC_ALL="C" date +"%a %b %d %Y")
175
176# tmp directory
177%tmpdir %(echo "${TMPDIR:-/tmp}")
178
179# Example files, programs, scripts...
180%_examplesdir /usr/src/examples
181
bd63739a 182# The directory holding Linux kernel sources
183%_kernelsrcdir /usr/src/linux
184
cd33aab7 185# If non-empty "debug" macro defined, add "dbg" suffix to release number
5b0f0ac9 186%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
cd33aab7 187
5b0f0ac9 188# Requires name = version-release
5237e419 189%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
511ee4c6 190
47fa9979
PS
191%releq_kernel_up() %(LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
192%releq_kernel_smp() %(LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
193%requires_releq_kernel_up() %(LC_ALL="C" rpm -qf --qf 'PreReq: %%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
194%requires_releq_kernel_smp() %(LC_ALL="C" rpm -qf --qf 'PreReq: %%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
511ee4c6 195
c7359865 196%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
d0bdd45a 197%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
e478b9e7 198
4ca2266c 199%apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
8dea1306 200
201# kernel version-release handling
31b569b6
ER
202%__kernel_ver %([ -f %{_kernelsrcdir}/include/linux/version.h ] && (grep UTS_RELEASE %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
203%__kernel_rel %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
ed0057d9 204%__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
31b569b6 205%_kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
066309eb 206%_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
fd4d8ee0 207
c2c27a5a 208# sgml macros
31b569b6
ER
209%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
210%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
211%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
212%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
213%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
214%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
c2c27a5a 215%docbook_sgmlcat_fix() { for l in \
216'' \
217' -- default decl --' \
218'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
219' -- hacks for opensp --' \
220'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
221'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
222'' \
223; do echo $l; done >> %1 \
224}
225
cd33aab7
AM
226#-----------------------------------------------------------------
227# find and gzip all files in %{_mandir} and %{infodir}
228#
229# Requires: xargs, find
230#
231#%no_install_post_compress_docs 1
232%__spec_install_post_compress_docs { \
cd33aab7 233%{!?no_install_post_compress_docs: \
89f18684 234 echo "Compress man and info pages."; \
cd33aab7
AM
235 %{?verbose:set -x;} \
236 for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
237 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
238 find "$RPM_BUILD_ROOT$i" -name \*.bz2 -print | xargs -r %{__bzip2} -df; \
239 find "$RPM_BUILD_ROOT$i" -name \*.gz -print | xargs -r %{__gzip} -dnf; \
240 find "$RPM_BUILD_ROOT$i" -type f -print | xargs -r %{__gzip} -9nf; \
241 fi; \
242 done; \
243} }
244
245#-----------------------------------------------------------------
246# Strip executable binaries and shared object files
247#
248# Requires: find, awk, strip, cut, xargs
249#
250#%no_install_post_strip 1
251%__spec_install_post_strip {%{!?debug: \
252%{!?no_install_post_strip: \
31b569b6
ER
253%{?verbose:set -x;} \
254 if [ -d "$RPM_BUILD_ROOT" ]; then \
5b0f0ac9 255 echo "Strip executable binaries, archives and shared object files."; \
1fcb29e9 256 filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
cd33aab7
AM
257 elfexelist=`echo $filelist | xargs -r file | \
258 awk '/ELF.*executable/ {print $1}' | cut -d: -f1`; \
259 elfsharedlist=`echo $filelist | xargs -r file | \
260 awk '/LF.*shared object/ {print $1}' | cut -d: -f1`; \
5b0f0ac9
MM
261 elfarchiveslist=`echo $filelist | xargs -r file | \
262 awk '/current ar archive/ {print $1}' | cut -d: -f1`; \
cd33aab7 263 if [ -n "$elfexelist" ]; then \
aaa1486f 264 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
cd33aab7
AM
265 fi; \
266 if [ -n "$elfsharedlist" ]; then \
aaa1486f 267 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
5b0f0ac9
MM
268 fi; \
269 if [ -n "$elfarchiveslist" ]; then \
aaa1486f 270 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $elfarchiveslist; \
f80cefa3 271 fi; \
31b569b6 272fi; } \
cd33aab7 273} }
31b569b6 274
cc545e1a 275#-----------------------------------------------------------------
276# remove all RPATH from executable binaries and shared object files
277#
278# Requires: find, awk, cut, xargs, chrpath, uname
279#
280#%no_install_post_chrpath 1
281%__spec_install_post_chrpath {%{!?debug: \
282%{!?no_install_post_chrpath: \
283 %{?verbose:set -x;} \
f80cefa3 284if [ -d "$RPM_BUILD_ROOT" ]; then \
cc545e1a 285echo "Remove RPATH from executable binaries and shared object files."; \
d274a19d 286find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"} | xargs -r file | \
3d66db15 287 awk '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}' | cut -d: -f1 | \
cc545e1a 288while read file ; do \
289 rpath= ; \
290 chmod u+w "$file"; \
291 for dir in `chrpath -l "$file" | \
31b569b6 292 awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
cc545e1a 293 case $dir in \
570a0c29 294 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
cc545e1a 295 echo "remove-rpath: $dir in $file"; \
296 ;; \
297 * ) \
298 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
299 else rpath="$rpath:$dir" ; fi ; \
300 ;; \
301 esac ; \
302 done ; \
303 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
304 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
f80cefa3
JB
305done; \
306fi; } \
cc545e1a 307} }
31b569b6 308
22a54b3e 309#-----------------------------------------------------------------
93b46c00 310# Find and gzip all kernel modules
311#
312# Requires: find
313#
314#%no_install_post_compress_modules 1
315%__spec_install_post_compress_modules { \
93b46c00 316%{!?no_install_post_compress_modules: \
31b569b6
ER
317 %{?verbose:set -x;} \
318 if [ -d "$RPM_BUILD_ROOT" ]; then \
319 echo "Compress kernel modules if any."; \
320 if test -d $RPM_BUILD_ROOT/lib/modules ; then \
321 find $RPM_BUILD_ROOT/lib/modules -name \*o -type f -print | \
322 xargs -r %{__gzip} -9nf; \
323 find $RPM_BUILD_ROOT/lib/modules -name \*o -type l -printf "%p %l\n" | \
324 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
325 fi; \
326 fi; \
93b46c00 327} }
cd33aab7 328
e4d71427
ER
329# Remove common Perl files we don't package
330%__spec_install_post_perl_clean {\
331%{!?no_install_post_perl_clean: \
332%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
333} }
334
aad1c8e4 335#-----------------------------------------------------------------
cc6c554c 336# Update GConf2 schemas
aad1c8e4 337#
338# Requires: GConf2
339#
5b8ed3c0 340%gconf_schema_install() \
31b569b6
ER
341 umask 022; \
342 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
343 %{nil}
5b8ed3c0 344
345%gconf_schema_uninstall() \
429d047e 346if [ $1 = 0 ]; then \
31b569b6
ER
347 umask 022; \
348 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
429d047e 349fi \
350%{nil}
351
352#-----------------------------------------------------------------
353# Update desktop MIME database
96999189 354# requires: desktop-file-utils
429d047e 355#
9ba5542a 356%update_desktop_database_post() {{ \
429d047e 357 umask 022; \
358 /usr/bin/update-desktop-database; \
17c49976 359}}
429d047e 360
38267983 361%update_desktop_database_postun() {{ \
429d047e 362if [ $1 = 0 ]; then \
363 umask 022; \
364 /usr/bin/update-desktop-database; \
365fi \
17c49976 366}}
429d047e 367
368#-----------------------------------------------------------------
369# Update scrollkeeper database
370# requires: scrollkeeper
371#
372%scrollkeeper_update_post() \
429d047e 373 /usr/bin/scrollkeeper-update -q; \
374 %{nil}
375
376%scrollkeeper_update_postun() \
377if [ $1 = 0 ]; then \
429d047e 378 /usr/bin/scrollkeeper-update -q; \
379fi \
380%{nil}
381
382#-----------------------------------------------------------------
383# Run ldconfig after installing/deinstalling libraries
384#
385%ldconfig_post() \
386 /sbin/ldconfig; \
387 %{nil}
388
389%ldconfig_postun() \
429d047e 390 /sbin/ldconfig; \
bbc02b2d 391 %{nil}
aad1c8e4 392
cd33aab7
AM
393#-----------------------------------------------------------------
394# post %install sequence:
395# - autodeps exceptions
396# - compress all man and info pages,
397# - strip all ELF executables and ELF shared objects if not %debug.
5b0f0ac9 398# - compress kernel modules if any
cd33aab7
AM
399
400###################################################################
401# Requires/Provides automation
402# exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
a4852742 403#
fbbdca08
JB
404%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
405%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
406%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
407%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
408%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
a4852742
JB
409#%_noautocompressdoc %{nil}
410#
5b0f0ac9
MM
411%_missing_doc_files_terminate_build 1%{nil}
412%_unpackaged_files_terminate_build %{nil}
4c7d3ba4 413# (X)emacs support
42b7e5ac 414%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
4c7d3ba4
AF
415%_emacs_lispdir %(emacs %___emacs_lispdir_helper)
416%_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
41a62699 417
984f6de6
JK
418%__php_provides %{nil}
419%__php_requires %{nil}
420%__perl_provides %{nil}
421%__perl_requires %{nil}
63b0a9d7 422%__mono_provides %{nil}
423%__mono_requires %{nil}
41a62699
AF
424
425# Perl specific macro definitions.
23c8318b
ER
426%perl_privlib %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
427%perl_archlib %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
428%perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
942c693c 429%perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
23c8318b
ER
430%perl_sitelib %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
431%perl_sitearch %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
41a62699 432
cb84f517 433# Ruby
75368847
ER
434%ruby_archdir %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
435%ruby_ridir %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
436%ruby_rubylibdir %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
437%ruby_sitearchdir %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
438%ruby_sitelibdir %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
439%ruby_version %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
5483bb35
ER
440%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
441%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
cb84f517 442
942c693c 443%php_pear_dir %{_datadir}/pear
41a62699 444
6b2157a6
ER
445# directory where php includes are installed on system.
446%__php_includedir /usr/include/php
f73da51b 447# extract php/zend api versions
09fac83f 448%php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
6b2157a6 449%php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
ab8d73ee 450%php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
6b2157a6
ER
451%zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
452%zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
ea702d15 453%zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
6b2157a6
ER
454
455# helper macro
e255dfdc 456%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
6b2157a6
ER
457
458# macros for public use
459# for php extensions (php-pecl)
ab8d73ee 460%requires_php_extension %{__php_api_requires modules_api php_api_version} \
e255dfdc
ER
461%{__php_api_requires -v %php_major_version debug php_debug} \
462%{__php_api_requires -v %php_major_version thread-safety zend_zts}
ab8d73ee 463
6b2157a6
ER
464# for zend extensions
465%requires_zend_extension %{__php_api_requires zend_module_api} \
ab8d73ee 466%{__php_api_requires zend_extension_api} \
e255dfdc
ER
467%{__php_api_requires -v %php_major_version debug php_debug} \
468%{__php_api_requires -v %php_major_version thread-safety zend_zts}
6b2157a6 469
41a62699
AF
470# Python specific macro definitions.
471# python main version
31b569b6 472%py_ver %(python -c "import sys; print sys.version[:3]")
41a62699
AF
473
474# directories
31b569b6
ER
475%py_prefix %(python -c "import sys; print sys.prefix")
476%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
a4f0b5e0 477%py_scriptdir %{py_prefix}/share/python%{py_ver}
31b569b6 478%py_incdir /usr/include/python%{py_ver}
a4f0b5e0
JK
479%py_sitedir %{py_libdir}/site-packages
480%py_sitescriptdir %{py_scriptdir}/site-packages
31b569b6 481%py_dyndir %{py_libdir}/lib-dynload
41a62699
AF
482
483# pure python modules compilation
31b569b6 484%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699 485
31b569b6 486%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699
AF
487
488# Software written in Python language require Python with main version
5177c7b1 489%pyrequires_eq() Requires: %1
41a62699 490
ea4b2900
AF
491# Hardlink binary identical .pyc and .pyo files
492# (idea by glen <at> pld-linux <dot> org)
493%__spec_install_post_py_hardlink {\
2b8c0cee 494%{!?no_install_post_py_hardlink: \
ea4b2900
AF
495[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
496 b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
497 if cmp -s "$a" "$b"; then \
498 ln -f "$a" "$b"; \
499 fi; \
500done \
501} }
502
16f6f416 503# remove python sources, so that check-files won't complain
ea4b2900
AF
504# (idea by glen <at> pld-linux <dot> org)
505%py_postclean() \
e4e8948b 506for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
9ba5542a 507 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
ea4b2900
AF
508done \
509%{nil}
510
67ed5b97 511# depmod macro
512%depmod() { \
fe30b3ea 513umask 022; \
67ed5b97 514if [ -e /boot/System.map-%1 ]; then \
31b569b6 515 /sbin/depmod -a -F /boot/System.map-%1 %1; \
67ed5b97 516else \
31b569b6
ER
517 if [ -e /boot/System.map ]; then \
518 /sbin/depmod -a -F /boot/System.map %1; \
519 else \
520 /sbin/depmod -a %1; \
521 fi \
67ed5b97 522fi; \
523}
524
495892af 525# XMMS specific macros
31b569b6
ER
526%xmms_prefix %(xmms-config --prefix 2>/dev/null)
527%xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null)
528%xmms_version %(xmms-config --version 2>/dev/null)
529%xmms_datadir %(xmms-config --data-dir 2>/dev/null)
530%xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null)
531%xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null)
532%xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null)
533%xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null)
534%xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null)
535%xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null)
495892af 536
bb128216
PS
537%_target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
538
e3618ee9 539# user/group checking macros
540#
541# Usage:
542# %userremove myuser
543#
544%userremove /usr/lib/rpm/user_group.sh user del
545%groupremove /usr/lib/rpm/user_group.sh group del
546#
547# Usage:
548# if %usertestrm myuser; then
549# /usr/sbin/userdel -r myuser
550# Note:
551# use these macros only if you need to call userdel/groupdel with
552# a non-standard option or take an extra action; otherwise use the
553# %userremove/%groupremove macros
554#
555%usertestrm /usr/lib/rpm/user_group.sh user testrm
556%grouptestrm /usr/lib/rpm/user_group.sh group testrm
13f70a2c
JK
557# user group membership management macros
558#
559# Usage:
560# %addusertogroup myuser agroup
561#
562%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
bfd9689c 563
564# banner support (useful in {pre,post}{,un} and triggers)
565#
566# Usage:
a980efc1 567# %banner name [-a] [-e] [-n] [-tn] <<EOF
bfd9689c 568# the banner text, the banner text
a980efc1
ER
569# the banner text, and following line
570#EOF
571# You can use any form of here-document, <<'EOF' <<-EOT will do.
572# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
573#
bfd9689c 574# -a - append to the banner
fb033326 575# -e - send to stderr instead of stdout
1257c400 576# -n - no show banner (overrides -t)
577# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
a980efc1 578%banner(aent:) \
f1bbc6ff 579RPM_SCRIPTVERBOSITY=5 \
580[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
581if [ -x /usr/bin/banner.sh ]; then \
a980efc1 582 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
f1bbc6ff 583else \
fb033326 584 CMD="cat%{-e: >&2}" \
f1bbc6ff 585fi \
f9cf2bf7 586eval $CMD %2%{?3: %3} \
bfd9689c 587%nil
1257c400 588
29c5556c
ER
589# useradd/groupadd macros written by glen@pld-linux.org.
590# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
591#
592# Usage:
593# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
594# [-g initial_group] [-G group[,...]] login
595#
596# -u uid. REQUIRED
597# -g gid/group. REQUIRED
598# -s defaults to /bin/false
599# -d defaults to /usr/share/empty
600# -c No default
601# -r is accepted but ignored (it's always set)
6eb25d5d 602# -k skeleton dir. defaults to /usr/share/empty
29c5556c
ER
603# rpm specific flags
604# -P package name. defaults to %{name}
605#
29c5556c 606%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
0044d46f
ER
607%{!-u:%{error:useradd: Required argument -u missing}} \
608%{!-g:%{error:useradd: Required argument -g missing}} \
609%{!?1:%{error:useradd: Required parameter login missing}} \
29c5556c
ER
610if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
611 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
612 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
613 exit 1 \
614 fi \
615else \
616 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
617 /usr/sbin/useradd \\\
cc333c8b 618 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
29c5556c
ER
619 -u %{-u*} \\\
620 -r \\\
621 -d %{-d*}%{!-d:/usr/share/empty} \\\
622 -s %{-s*}%{!-s:/bin/false} \\\
85e3e9a1 623 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
29c5556c
ER
624 -g %{-g*} \\\
625 %{-M} \\\
626 %{-G:-G %{-G*}} \\\
85e3e9a1 627 %{expand:%{%{#}}} 1>&2 \
29c5556c
ER
628fi;
629
29c5556c
ER
630# Usage:
631# %groupadd [-P package] [-g gid] group
632#
633# -g gid. REQUIRED
634#
635# Sample:
636# %groupadd -P %{name}-base -g %{gid} %{name}
637
638%groupadd(g:P:rfo) \
0044d46f
ER
639%{!-g:%{error:groupadd: Required argument -g missing}} \
640%{!?1:%{error:groupadd: Required parameter group missing}} \
29c5556c
ER
641if [ -n "`/usr/bin/getgid %{1}`" ]; then \
642 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
643 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
644 exit 1 \
645 fi \
646else \
647 echo "Adding group %{1} GID=%{-g*}." \
85e3e9a1 648 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 \
29c5556c 649fi;
053b8de1
ER
650
651# apache_config_{install/uninstall} macros written by glen@pld-linux.org.
652# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
653#
654# The config is installed/removed inside trigger, this means that you can any
655# time install apache1 or apache package and the configuration file is updated.
656# if you don't need the config for various reason for specific apache, just
657# remove the symlink from apache config directory. the trigger will not put the
658# config again to that version of apache. In other words the config is linked
659# to apache config directory on first install of PACKAGE or apache.
660#
661# should be called in trigger body:
662# %triggerin -- apache1 >= 1.3.33-2
663# %apache_config_install -v 1
664#
665# Add package's apache config to apache config.
666#
667# Usage:
668# %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
669#
670# -v REQUIRED: specify apache version. can be 1 or 2.
671# -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
672# -n OPTIONAL: specify config "slot". defaults to 99
22d9c327 673# -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
053b8de1
ER
674#
675# Internal macros. don't use ;).
676# expands apache config dir by apache version at build time.
677%__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
678# expands apache service name by apache version at build time.
679%__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
680
22d9c327 681%apache_config_install(fv:c:n:) \
053b8de1
ER
682%{!-v:%{error:apache_config_install: Required argument -v missing}} \
683%{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
22d9c327 684if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
053b8de1
ER
685 ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
686fi\
7e4c6837 687# reload apache if the config symlink is there\
1d90410b 688if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
71d37358
ER
689 # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
690 if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
7e4c6837 691 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
053b8de1
ER
692 fi\
693fi\
694%{nil}
695
696# Remove package's apache config from apache config.
697#
698# Usage:
699# %apache_config_uninstall -v {1|2} -n 99
700#
701# -v REQUIRED: specify apache version. can be 1 or 2.
702# -n OPTIONAL: specify config "slot". defaults to 99
703%apache_config_uninstall(v:n:) \
704%{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
705%{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
9e0d77bc 706# remove link if either of the packages are gone \
053b8de1
ER
707if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
708 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
709 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
710 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
7e4c6837 711 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
053b8de1
ER
712 fi \
713 fi \
714fi \
715%{nil}
716
55a50f1a 717# webapp macros
ba42a822
ER
718#
719# The config is installed/removed inside trigger, this means that you can any
720# time install apache1/apache/lighttpd package and the configuration file is
721# updated. if you don't need the config for various reason for specific
722# webserver, just remove the symlink from config directory using webapp
723# program. the trigger will not recreate the symlink on upgrades. In other
724# words the config is linked to webserver config directory on first install of
725# PACKAGE or WEBSERVER.
726#
55a50f1a
ER
727# Add package's webserver config to webserver webapps dir.
728# Usage:
217f2cb2 729# %webapp_register WEBSERVER WEBAPP
ba42a822
ER
730#
731%webapp_register() \
732%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
733if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
734 /usr/sbin/webapp register %1 %2\
735fi\
973c1dc7 736# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
57ff17b4 737if [ -L /etc/%1/webapps.d/%2.conf ] && [ "$2" -lt "2" ]; then\
5f0b2e29 738 %{expand:%service -q %%1 reload}\
ba42a822
ER
739fi\
740%{nil}
741
742# Remove package's config from webserver webapps dir.
ba42a822 743# Usage:
b9588fe6
ER
744# %webapp_register [-f] WEBSERVER WEBAPP
745%webapp_unregister(f) \
ba42a822
ER
746%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
747# remove link if either of the packages are gone \
b9588fe6 748if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%2.conf ]; then \
217f2cb2 749 /usr/sbin/webapp unregister %1 %2\
5f0b2e29 750 %{expand:%service -q %%1 reload}\
ba42a822
ER
751fi \
752%{nil}
753
745c4676
ER
754# see browser-plugins.spec / template-browser-plugin.spec
755# written by glen@pld-linux.org.
f6565dd0 756%nsplugin_install(d:f) { \
745c4676 757# create link if it's first install of either of the packages \
f6565dd0 758if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
745c4676
ER
759( \
760%( \
761 for file in %{*}; do \
762 echo echo Installing $file to %{-d*}; \
763 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
764 done ) \
765) | ( %banner -t 5 -e %{name}-in ); fi; \
766}
767
3e680cb6 768%nsplugin_uninstall(d:) { \
745c4676
ER
769# remove link if either of the packages are gone \
770if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
771( \
772%( \
773 for file in %{*}; do \
774 echo echo Removing $file from %{-d*}; \
775 echo "rm -f %{-d*}/$file;"; \
776 done ) \
777) | ( %banner -t 5 -e %{name}-un ); fi; \
778}
8edf8498
ER
779
780# service macro.
781#
782# calls usual service restart on package %post, but skips the restart if
783# administrator has disabled automatic service restarts in either global
784# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
785#
786# written by glen@pld-linux.org.
787# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
788#
789# Usage:
524e081b 790# %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
8edf8498
ER
791#
792# -q be silent when service isn't started (for postun scriplets)
793#
e42cbd35 794%service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
This page took 0.259295 seconds and 4 git commands to generate.